{
 Пример параллельного исполнения процедур (par1.pp).
 Программа запускает 4 параллельных процедуры,
 заполняющих экран EV3 вертикальной и горизонтальной 
 штриховкой, затем в основном потоке отыгрывает 
 стартовую мелодию, ожидает завершения 
 параллельных процедур и отыгрывает завершающую
 мелодию.
}
{$i rubiro.inc}
uses rubiroBase,rubiroSound,rubiroScreen,rubiroParallel;

procedure lr_draw(l2r:variant);
  var i:integer;
 begin
   for i:=1 to 45 do 
    if l2r then ev3Screen.line(i*3,0,i*3,128).show
    else ev3Screen.line(178-i*3,0,178-i*3,128).show;
 end;

procedure ud_draw(u2d:variant);
  var i:integer;
 begin
   for i:=1 to 30 do 
   if u2d then ev3Screen.line(0,i*3,178,i*3).show
   else ev3Screen.line(0,128-i*3,178,128-i*3).show;
 end;

 var pl,pr,pu,pd:dword;
begin
 ev3init();
 pl:=parallel(@lr_draw,true);
 pr:=parallel(@lr_draw,false);
 pu:=parallel(@ud_draw,true);
 pd:=parallel(@ud_draw,false);
 ev3sound.beep(signal2);
 parallelWait(pl);
 parallelWait(pr);
 parallelWait(pu);
 parallelWait(pd);
 ev3sound.beep(signal1);
end.
